package com.fp.persistence.parmas.inte;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMTAGARMA*/
@Entity(name="TarmTagArma")
@Table(name="TARMTAGARMA")
public class TarmTagArma extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
	
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmTagArma
*/
@EmbeddedId
private TarmTagArmaKey pk;
@Column(name="FECHA", nullable=true)

/**
* Fecha de vigencia del Tag
*/
private Timestamp fecha;

/**Contructor por defecto*/
public TarmTagArma(){
}
/**Contructor de TarmTagArma
@param pPk Clave Primaria del entity
*/
public TarmTagArma(TarmTagArmaKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmTagArma
*/
public static TarmTagArma find(EntityManager pEntityManager,TarmTagArmaKey pKey) throws Exception{
    TarmTagArma obj = pEntityManager.find(TarmTagArma.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmTagArma
@return El objeto que referencia a la Clave primaria de TarmTagArma
*/
public TarmTagArmaKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmTagArma
@param pPk El objeto que referencia a la nueva Clave primaria de TarmTagArma
*/
public void setPk(TarmTagArmaKey pPk){
  pk=pPk;
}
/**Obtiene el valor de fecha
@return valor de fecha*/
public Timestamp getFecha(){
  return fecha;
}
/**Fija el valor de fecha
@param pFecha nuevo Valor de fecha*/
public void setFecha(Timestamp pFecha){
  fecha=pFecha;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmTagArma))return false;
    TarmTagArma that = (TarmTagArma) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmTagArma
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmTagArma
*/
public Object createInstance(){
 TarmTagArma instance=new TarmTagArma();	
 instance.setPk(new TarmTagArmaKey());
 return instance;
}
/**Clona la entidad TarmTagArma
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmTagArma p=(TarmTagArma)this.clone();
  p.setPk((TarmTagArmaKey)this.pk.cloneMe());
  return p;
}
}
